
#include"16F873.h"
#include "define.h"
#include "interrupt.c"
#include "uart.c"

unsigned int iCode1;
unsigned char cCodeA,cCodeS,cCodeAmem,cErr;
unsigned char cFlag,cCurseur;
unsigned char temp;

void Raz(void)
   {
   iCode1=0;
   cFlag=8;
   }

//** traitement des touches en fonction de cCodeS **

 void Touche(void)
   {
   print_dec(cCodeS);
   print_str("\n\r");
   if(cCodeS==1) printf('1');
   if(cCodeS==2) printf('2');
   if(cCodeS==3) printf('3');
   if(cCodeS==4) printf('4');
   if(cCodeS==0x10) printf('5');  // Volume +
   if(cCodeS==0x11) printf('6'); // Volume -
   if(cCodeS==0x20) printf('7'); // programme +
   if(cCodeS==0x21) printf('8'); // programme -
   Raz();
   }

 //** rception du code RC5 dans la variable cCodeS **

 void RC5(void)
   {
   if(cFlag==0)
	{
	TMR0=199; // 2,427ms
	T0IE=1;
	cFlag=1;
	}

   if(cFlag==2)
	{
	TMR0=214; // 1,765ms
	T0IE=1;
	cFlag=3;
	}

  if(cFlag==4)
	{
	T0IE=0;
	if(cErr==0)
		{
		cFlag=5;
		return;
		}

	iCode1.0=1;
	if(PORTA.4) iCode1.0=0;
	cFlag=2;

	if(cCurseur>1)
		{
		iCode1=iCode1<<1;
		cCurseur--;
		}
	     else
	         {
	         cFlag=5;
           temp = iCode1 ;
           temp = temp & 63 ;
           cCodeS = temp ;
           temp = iCode1 ;
           temp = temp >> 6 ;
           temp = temp & 63 ;
           cCodeA = temp ;
//	         cCodeA=(iCode1 >> 6) & 63; //    rep a4 a3 a2 a1 a0
	        }
	}
   if(!PORTA.4)cErr=1;
  }


 void inter(void)
   {
   if(T0IF)
        {
        if(cFlag<=3 || cFlag==6) cFlag++;
        T0IF=0;
        }
   }



void main(void)   //** dbut de Main **
{
GIE=1; T0IE=0;
TRISA=0b10000; // RA4 entre signal RC5
TRISB=0;
TRISC=0x80;
OPTION=0b10000110;// 128

setupUART();
print_str("bonjour\n\r");

cErr=0;
cCodeAmem=0;
TMR0=1;
T0IE=1;
while(TMR0 !=0);
T0IE=0;
Raz();

 while(1)   // boucle while
   {
   if(cFlag==5)
      {
      cFlag=6;
      TMR0=1;
      T0IE=1;
      }

   if((cFlag>=8) && (!PORTA.4))
      {
      cFlag=0;
      cCurseur=12;
      cErr=0;
      }

   if(cFlag<=4)  RC5();
   if(cFlag==7)  Touche();
  }
} //** fin de Main **

